* [Hello World](#hello-world)
* [Bindings](#bindings)
* [Dynamic Bindings](#dynamic-bindings)
* [Forward Bindings](#forward-bindings)
* [Multiple Bindings](#multiple-bindings)
* [Binding Non-owning Pointer](#binding-non-owning-pointer)
* [Automatic Injection](#automatic-injection)
* [Constructor Signature](#constructor-signature)
* [Constructor Injection](#constructor-injection)
* [Multiple Interface](#multiple-interfaces)
* [Annotations](#annotations)
* [Deduce Scope](#deduce-scope)
* [Custom Scope](#custom-scope)
* [Eager Singletons](#eager-singletons)
* [Modules](#modules)
* [Modules (hpp/cpp)](#modules-hppcpp)
* [Custom Policy](#custom-policy)
* [Custom Provider](#custom-provider)
* [Pool Provider](#pool-provider)
* [Configuration](#configuration)

---

###Hello World
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/hello_world.cpp)

###Bindings
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/bindings.cpp)

###Dynamic Bindings
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/dynamic_bindings.cpp)

###Forward Bindings
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/fwd_bindings.cpp)

###Multiple Bindings
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/multiple_bindings.cpp)

###Binding Non-owning Pointer
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/bind_non_owning_ptr.cpp)

###Automatic Injection
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/automatic_injection.cpp)

###Constructor Signature
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/constructor_signature.cpp)

###Constructor Injection
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/constructor_injection.cpp)

###Multiple Interface
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/multiple_interfaces.cpp)

###Annotations
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/annotations.cpp)

###Deduce Scope
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/deduce_scope.cpp)

###Custom Scope
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/custom_scope.cpp)

###Eager Singletons
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/eager_singletons.cpp)

###Modules
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/modules.cpp)

###Modules (hpp/cpp)

* See [https://github.com/boost-experimental/di/tree/cpp14/example/modules](https://github.com/boost-experimental/di/tree/cpp14/example/modules)

###Custom Policy
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/custom_policy.cpp)

###Custom Provider
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/custom_provider.cpp)

###Pool Provider
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/pool_provider.cpp)

###Configuration
![CPP](https://raw.githubusercontent.com/boost-experimental/di/cpp14/example/configuration.cpp)
